
//Title:        Talker
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:  



import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Talk extends JFrame implements graphInterface {
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  List list1 = new List();
  JTextField jTextField1 = new JTextField();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField2 = new JTextField();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Client client;

  public Talk(String ip) {
    try  {
      jbInit();
      setSize(300,200);
      show();
      client= new Client(this,ip);
      client.esegui();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(gridBagLayout1);
    jTextArea1.setText("");
    jTextField1.setText("");
    jTextArea1.setAutoscrolls(true);
    jScrollPane1.setAutoscrolls(true);
    jTextField1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jTextField1_actionPerformed(e);
      }
    });
    jLabel1.setText("Insert Nickname:");
    jTextField2.setText("nick");
    jTextField2.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jTextField2_actionPerformed(e);
      }
    });
    jButton1.setText("Connect");
    jButton1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jButton2.setText("Talk");
    jButton2.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    list1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        list1_actionPerformed(e);
      }
    });
    this.getContentPane().add(jScrollPane1, new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 0, 0), 317, 142));
    this.getContentPane().add(list1, new GridBagConstraints(0, 1, 1, 5, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 1, 0), 39, 127));
    this.getContentPane().add(jTextField1, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 164, 3));
    this.getContentPane().add(jLabel1, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 133, 3));
    this.getContentPane().add(jTextField2, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 0, 0, 0), 198, 2));
    this.getContentPane().add(jButton1, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 143, -2));
    this.getContentPane().add(jButton2, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(23, 48, 13, 47), 76, 22));
    jScrollPane1.getViewport().add(jTextArea1, null);
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }

  void jButton1_actionPerformed(ActionEvent e) {
    client.myUser.setNick(jTextField2.getText());
    client.connect();
    setTitle("Talk - " + jTextField2.getText());
  }

  void jButton2_actionPerformed(ActionEvent e) {
    int i;
    i=list1.getSelectedIndex();
    if(i!=-1) client.startChat(list1.getItem(i));
  }

  void jTextField1_actionPerformed(ActionEvent e) {
    client.sendMsg(jTextField1.getText());
    jTextField1.setText("");
  }

   public void addList(User u){
    int nrow,i;
    boolean ins=false;
    nrow=list1.getItemCount();
    if(nrow!=0){
      for(i=0;i<nrow && !ins;i++){
        if((u.getNick()).compareToIgnoreCase(list1.getItem(i))<0){
          list1.add(u.getNick(),i);
          ins=true;
        }
      }
      if(!ins) list1.add(u.getNick());
    }else
    list1.add(u.getNick());
  }

  public void removeList(User u){
    list1.remove(u.getNick());
  }

   public void scriviMsg(String s){
    jTextArea1.append("\n" + s);
  }

  void jTextField2_actionPerformed(ActionEvent e) {
    client.myUser.setNick(jTextField2.getText());
    client.connect();
    setTitle("Talk - " + jTextField2.getText());
  }

  void list1_actionPerformed(ActionEvent e) {
    client.startChat(list1.getItem(list1.getSelectedIndex()));
  }


}
