import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;


public class TalkApplet extends JApplet implements graphInterface {
  boolean isStandalone = false;
  String ipserver;
  List list1 = new List();
  Label label1 = new Label();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  JTextField jTextField1 = new JTextField();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField2 = new JTextField();
  JButton jButton1 = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  Client client;
  
  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public TalkApplet() {
  }

  //Initialize the applet
  public void init() {
    try { ipserver = this.getParameter("ipserver", "localhost"); } catch (Exception e) { e.printStackTrace(); }
    try  {
      jbInit();
      client=new Client(this,ipserver);
      client.esegui();
    }
    catch(Exception e)  {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(gridBagLayout1);
    label1.setText("Users List:");
    jTextArea1.setText("jTextArea1");
    jTextField1.setText("jTextField1");
    jLabel1.setText("Insert Nickname:");
    jTextField2.setText("jTextField2");
    jButton1.setText("Connetti");
    this.getContentPane().add(list1, new GridBagConstraints(0, 1, 1, 5, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 4, 5, 0), 16, 278));
    this.getContentPane().add(label1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 4, 0, 0), 66, -4));
    this.getContentPane().add(jScrollPane1, new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 6, 0, 7), 293, 161));
    this.getContentPane().add(jTextField1, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 7, 0, 7), 303, -1));
    this.getContentPane().add(jLabel1, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 8, 0, 7), 272, 6));
    this.getContentPane().add(jTextField2, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 8, 0, 7), 302, -1));
    this.getContentPane().add(jButton1, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(8, 7, 54, 7), 285, 9));
    jScrollPane1.getViewport().add(jTextArea1, null);
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo = 
    {
      {"ipserver", "String", ""},
    };
    return pinfo;
  }
  // static initializer for setting look & feel
  static {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch (Exception e) {}
  }

  public void scriviMsg(String s){
    this.jTextArea1.append(s + "\n");
  }

     public void addList(User u){
    int nrow,i;
    boolean ins=false;
    nrow=list1.getItemCount();
    if(nrow!=0){
      for(i=0;i<nrow && !ins;i++){
        if((u.getNick()).compareToIgnoreCase(list1.getItem(i))<0){
          list1.add(u.getNick(),i);
          ins=true;
        }
      }
      if(!ins) list1.add(u.getNick());
    }else
    list1.add(u.getNick());
  }

  public void removeList(User u){
    list1.remove(u.getNick());
  }
}
                    
