
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:

import java.io.*;

/**
  * Questa classe genera un Thread dedicato all'invio
  * di messaggi a Thread di tipo chatterReceiver.
  * In questo modo viene realizzata la separazione fra flusso di Input e
  * flusso di Output
*/
public class chatterSender extends Thread {

private Chatter chatterPadre;
private ObjectOutputStream output;

  public chatterSender(Chatter c,ObjectOutputStream out) {
  /**
  * Costruttore della classe
  */
    chatterPadre=c;
    output=out;
  }

  public void send(Object o){
    try{
      output.writeObject(o);
    }catch(IOException e){
      chatterPadre.riceviMsg("Errore di trasmissione");
    }
  }

  public void run(){
  }
}
