
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:


import java.net.*;
import java.io.*;

public class serverListener extends Thread {
private ServerSocket listenServer;
private Client clientPadre;
private ObjectInputStream in;
private ObjectOutputStream out;

  public serverListener(Client c){
    clientPadre=c;
    try{
      listenServer=new ServerSocket(0);
      start();
    }catch(IOException e){//cade il serverlistener...deve essere riavviato
    }
  }

  public Integer getListenerPort(){
    Integer i=new Integer(listenServer.getLocalPort());
    return i;
  }

  public void run(){
  String str;
  int i;
    while(true){
      try{
        Socket socket=listenServer.accept();
        in=new ObjectInputStream(socket.getInputStream());
        out=new ObjectOutputStream(socket.getOutputStream());
        str=(String)riceviMsg();
        if(str.equals("Adduser")){
          sendMsg("OK");
          User newUser=(User)riceviMsg();
          str=clientPadre.ListaUtenti.addUser(newUser);
          clientPadre.talkui.addList(newUser);
          sendMsg("OK");
        }
        if(str.equals("Removeuser")){
          sendMsg("OK");
          User newUser=(User)riceviMsg();
          int j=clientPadre.ListaUtenti.removeUser(newUser);
          clientPadre.talkui.removeList(newUser);
          sendMsg("OK");
        }
        if(str.equals("Reconnect")){
          clientPadre.Reconnect(socket.getInetAddress().getHostAddress());
        }
        //Altri comandi da implementare
      }catch(IOException e){
        //clientPadre.scriviMsg("Caduta connessione temporanea con il Server");
        //cade la connessione temporanea con il server...boh
      }
    }
  }

  public Object riceviMsg(){
    try{
      return in.readObject();
    }catch(Exception e){
      return null;
    }
  }

  public void sendMsg(Object o){
    try{
      out.writeObject(o);
    }catch (IOException e){}
  }
}
