
//Title:        Talker
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:  


import java.io.*;

/**
* Questa classe definisce l'utente del sistema
*/

public class User implements Serializable {
  /**
  * Indirizzo IP dell'Utente
  */
  private String IndIP;
  /**
  * NickName Utente
  */
  private String Nick;
  /**
  * Porta di ascolto delle comunicazioni dal Server
  */
  private Integer serverListenerPort;
  private Integer clientListenerPort;
  private String password;

  public User(){}

  public User (String nick, String ind, String pwd, Integer srv, Integer cli){
    Nick=nick;
    IndIP=ind;
    serverListenerPort=srv;
    clientListenerPort=cli;
    password=pwd;
  }

  public String getIndIP(){
    return this.IndIP;
  }

  public String getNick(){
    return this.Nick;
  }

  public Integer getClientListenerPort(){
    return clientListenerPort;
  }

  public Integer getServerListenerPort(){
    return serverListenerPort;
  }

  public String getPassword(){
    return password;
  }

  public void setIndIP(String indip){
    this.IndIP=indip;
  }

  public void setNick(String nick){
    this.Nick=nick;
  }

  public void setClientListenerPort(Integer port){
    clientListenerPort=port;
  }

  public void setServerListenerPort(Integer port){
    serverListenerPort=port;
  }

  public boolean isEqualNick(String nick){
    if(Nick.equals(nick)) return true;
    return false;
  }

  public boolean isEqualIP(String indIP){
    if(IndIP.equals(indIP))return true;
    return false;
  }
  public boolean isEqual(User user){
    if((Nick.equals(user.getNick())&&(IndIP.equals(user.getIndIP()))))
    return true;
    return false;
  }


}
