
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:

import java.io.*;

  /**
  * Questa classe genera un Thread dedicato alla esclusiva ricezione
  * di messaggi da Thread di tipo chatterSender.
  * In questo modo viene realizzata la separazione fra flusso di Input e
  * flusso di Output
  */

public class chatterReceiver extends Thread {

private Chatter chatterPadre;
private ObjectInputStream input;

  /**
  * Costruttore della classe
  */
  public chatterReceiver(Chatter c,ObjectInputStream in) {

    chatterPadre=c;
    input=in;
  }

  /**
   * Metodo implementato in quanto questa classe eredita dalla classe Thread
   * Crea un ciclo di attesa del flusso di input
  */
  public void run(){

    try{
      while(true){
        chatterPadre.riceviMsg(((String)input.readObject()));
      }//fine while
    }//FINE TRY
    catch(Exception e){
      chatterPadre.riceviMsg("Errore Ricezione");
    }
  }
}
